/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2003 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.0 of the PHP license,       |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/3_0.txt.                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Pierre-Alain Joye <paj@pearfr.org>                           |
  +----------------------------------------------------------------------+

  $Id: php_date.h,v 1.4 2004/03/05 12:21:10 pajoye Exp $
*/

#ifndef PHP_DATE_H
#define PHP_DATE_H
#include "t_date.h"

extern zend_module_entry date_module_entry;
#define phpext_date_ptr &date_module_entry

#ifdef PHP_WIN32
#define PHP_DATE_API __declspec(dllexport)
#else
#define PHP_DATE_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

static void date_objects_dtor(void *object, zend_object_handle handle TSRMLS_DC);
void date_write_property(zval *object, zval *member, zval *value TSRMLS_DC);
zval *date_read_property(zval *object, zval *member, zend_bool silent TSRMLS_DC);
PHP_DATE_API zend_object_value date_objects_new(zend_class_entry * TSRMLS_DC);

zend_class_entry *date_class_entry;

typedef struct _date_object {
        zend_object zo;
        Date *ptr;
} date_object; /* extends zend_object */


PHP_MINIT_FUNCTION(date);
PHP_MSHUTDOWN_FUNCTION(date);
PHP_RINIT_FUNCTION(date);
PHP_RSHUTDOWN_FUNCTION(date);
PHP_MINFO_FUNCTION(date);


PHP_FUNCTION(date_ctor);

PHP_FUNCTION(date_new);
PHP_FUNCTION(date_free);
PHP_FUNCTION(date_new_julian);
PHP_FUNCTION(date_new_dmy);
PHP_FUNCTION(date_new_now);
PHP_FUNCTION(date_valid);
PHP_FUNCTION(date_valid_julian);
PHP_FUNCTION(date_valid_dmy);
PHP_FUNCTION(date_set_dmy);
PHP_FUNCTION(date_set_day);
PHP_FUNCTION(date_get_day);
PHP_FUNCTION(date_set_month);
PHP_FUNCTION(date_get_month);
PHP_FUNCTION(date_set_year);
PHP_FUNCTION(date_get_year);
PHP_FUNCTION(date_set_julian);
PHP_FUNCTION(date_get_julian);
PHP_FUNCTION(date_is_leap_year);
PHP_FUNCTION(date_add_days);
PHP_FUNCTION(date_sub_days);
PHP_FUNCTION(date_add_weeks);
PHP_FUNCTION(date_sub_weeks);
PHP_FUNCTION(date_add_months);
PHP_FUNCTION(date_sub_months);
PHP_FUNCTION(date_add_years);
PHP_FUNCTION(date_sub_years);
PHP_FUNCTION(date_days_between);
PHP_FUNCTION(date_compare);
PHP_FUNCTION(date_order);
PHP_FUNCTION(date_clamp);
PHP_FUNCTION(date_get_weekday);
PHP_FUNCTION(date_get_day_of_year);
PHP_FUNCTION(date_get_week_of_year);
PHP_FUNCTION(date_get_isoweek_of_year);
PHP_FUNCTION(date_set_to_weekday);
PHP_FUNCTION(date_get_to_weekday);
PHP_FUNCTION(date_set_to_last_month_day);
PHP_FUNCTION(date_get_to_last_month_day);
PHP_FUNCTION(date_set_to_prev_week_day);
PHP_FUNCTION(date_get_to_prev_week_day);
PHP_FUNCTION(date_set_to_next_weekday);
PHP_FUNCTION(date_get_to_next_weekday);
PHP_FUNCTION(date_set_to_weekday_in_same_week);
PHP_FUNCTION(date_get_to_weekday_in_same_week);
PHP_FUNCTION(date_set_to_week);
PHP_FUNCTION(date_get_to_week);
PHP_FUNCTION(date_set_last_dow);
PHP_FUNCTION(date_get_last_dow);
PHP_FUNCTION(date_set_first_dow);
PHP_FUNCTION(date_get_first_dow);
PHP_FUNCTION(date_get_days_in_month);
PHP_FUNCTION(date_get_weeks_of_year);
PHP_FUNCTION(date_strftime);
PHP_FUNCTION(date_get_array);
PHP_FUNCTION(date_get_easter);

/*
  	Declare any global variables you may need between the BEGIN
	and END macros here:
*/
/*ZEND_BEGIN_MODULE_GLOBALS(date)
	int   dates_counter;*/
	/* char *global_string;*/
/*ZEND_END_MODULE_GLOBALS(date)
*/

/* In every utility function you add that needs to use variables
   in php_date_globals, call TSRM_FETCH(); after declaring other
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as DATE_G(variable).  You are
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define DATE_G(v) TSRMG(date_globals_id, zend_date_globals *, v)
#else
#define DATE_G(v) (date_globals.v)
#endif

#endif	/* PHP_DATE_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
